package rip.tilly.bedwars.providers.scoreboard;

import rip.tilly.bedwars.utils.assemble.AssembleAdapter;
import org.bukkit.entity.Player;
import rip.tilly.bedwars.BedWars;
import rip.tilly.bedwars.player.PlayerData;
import rip.tilly.bedwars.utils.CC;

import java.util.ArrayList;
import java.util.List;

import static rip.tilly.bedwars.utils.CC.translate;

public class ScoreboardProvider implements AssembleAdapter {

    private BedWars main = BedWars.getInstance();

    @Override
    public String getTitle(Player player) {
        return CC.translate("&d&lBedWars");
    }

    @Override
    public List<String> getLines(Player player) {
        PlayerData playerData = this.main.getPlayerDataManager().getPlayerData(player.getUniqueId());

        if (!playerData.getPlayerSettings().isScoreboardEnabled()) {
            return null;
        }

        switch (playerData.getPlayerState()) {
            case SPAWN:
                return this.spawnScoreboard(playerData);
            case PLAYING:
                return null;
            case SPECTATING:
                return null;
        }

        return null;
    }

    private List<String> spawnScoreboard(PlayerData playerData) {
        List<String> strings = new ArrayList<>();

        strings.add(CC.scoreboardBar);
        strings.add("&fOnline: &d" + this.main.getServer().getOnlinePlayers().size());
        strings.add("&fPlaying: &d");
        strings.add(" ");

        if (true) {
            strings.add("&fLevel: &d" + playerData.getLevel());

            String finishedProgress = "";

            int notFinishedProgress = 10;

            for (int i = 0; i < playerData.getXp() * 100; i++) {
                if (i % 10 == 0) {
                    finishedProgress += "⬛";

                    notFinishedProgress--;
                }
            }

            String leftOverProgress = "";

            for (int i = 1; i <= notFinishedProgress; i++) {
                leftOverProgress += "⬛";
            }

            strings.add("&8" + finishedProgress + "&7" + leftOverProgress + " &7(" + ((int) (playerData.getXp() * 100)) + "%&7)");
            strings.add(" ");
        }

        strings.add("&dtilly.rip");
        strings.add(CC.scoreboardBar);

        return translate(strings);
    }
}
